#! /bin/sh
# Mike Oz McGill University August 2003
# Caveat assumes first residue in sequence file is 
# numbered as 1, any other referencing need to alter value of i in the line with
#"while (getline" command "resnuma[i] = i" e.g. as 'resnuma[i] = i+5"
if [ $# != 1 ]
    then
      echo "usage: nmr2bmrb.s  <nmrview ppm file>"
      exit 1
fi


nawk ' 
BEGIN{
OFS=" "
FS=" "        
RS = "\n"
#	print "#Res \t S2(exp) \t\t dS2(exp) "
#  file1  =ARGV[1] 
#  ARGV[1]=""
#  file2  =ARGV[2] 
#  ARGV[2]=""

i=0


while (getline < ARGV[1] > 0){ i++;sub(/\./," ");sub(/\./," ");gsub(/\:/," fuck ");gsub(/\{/,"");gsub(/\}/,"");resnamb[i] = $1;split($1,p2,":");resnumb[i] = $1; atnamb[i] = $2; atnamc[i] = $3 ; atnamd[i] = $4; atname[i] = $5; \
atnamf[i] = $6 ; atnamg[i] = $7; atnamh[i] = $8; atnami[i] = $9 ; atnamj[i] = $10; atnamk[i] = $11; atnaml[i] = $12; atnamm[i] = $13

}

 nra=i
}
END{


#this is an important loop and needs to be chagned for each protein
for (i = 1; i <= nra; i++){
{if (resnumb[i] =="assi" && atnamd[i] =="71" && atname[i] == "HG21") wank[i]="HG2#"	#thr 71

else if (resnumb[i] =="assi" && atnamd[i] =="41" && atname[i] == "HB1") wank[i]="HB#"	#Ala 41
else if (resnumb[i] =="assi" && atnamd[i] =="48" && atname[i] == "HB1") wank[i]="HB#"	#Ala 48
else if (resnumb[i] =="assi" && atnamd[i] =="52" && atname[i] == "HB1") wank[i]="HB#"	#Ala 
else if (resnumb[i] =="assi" && atnamd[i] =="66" && atname[i] == "HB1") wank[i]="HB#"	#Ala 
else if (resnumb[i] =="assi" && atnamd[i] =="72" && atname[i] == "HB1") wank[i]="HB#"	#Ala 
else if (resnumb[i] =="assi" && atnamd[i] =="76" && atname[i] == "HB1") wank[i]="HB#"	#Ala 
else if (resnumb[i] =="assi" && atnamd[i] =="78" && atname[i] == "HB1") wank[i]="HB#"	#Ala 
else if (resnumb[i] =="assi" && atnamd[i] =="79" && atname[i] == "HB1") wank[i]="HB#"	#Ala 
else if (resnumb[i] =="assi" && atnamd[i] =="85" && atname[i] == "HB1") wank[i]="HB#"	#Ala 

#else if (resnumb[i] =="assi" && atnamd[i] =="29" && atname[i] == "HD11") wank[i]="HD1#"	#LEU can also make this HD##
#else if (resnumb[i] =="assi" && atnamd[i] =="29" && atname[i] == "HD21") wank[i]="HD2#"	#LEU can also make this HD##
#else if (resnumb[i] =="assi" && atnamd[i] =="37" && atname[i] == "HD11") wank[i]="HD1#"	#LEU can also make this HD##
#else if (resnumb[i] =="assi" && atnamd[i] =="37" && atname[i] == "HD21") wank[i]="HD2#"	#LEU can also make this HD##
else if (resnumb[i] =="assi" && atnamd[i] =="29" && atname[i] == "HD11") wank[i]="HD#"	#LEU can also make this HD##
else if (resnumb[i] =="assi" && atnamd[i] =="29" && atname[i] == "HD21") wank[i]="HD#"	#LEU can also make this HD##
else if (resnumb[i] =="assi" && atnamd[i] =="37" && atname[i] == "HD11") wank[i]="HD#"	#LEU can also make this HD##
else if (resnumb[i] =="assi" && atnamd[i] =="37" && atname[i] == "HD21") wank[i]="HD#"	#LEU can also make this HD##

else if (resnumb[i] =="assi" && atnamd[i] =="44" && atname[i] == "HD11") wank[i]="HD1#"	#ILE can also make this HD##
else if (resnumb[i] =="assi" && atnamd[i] =="44" && atname[i] == "HG21") wank[i]="HG2#"	#ILE can also make this HD##

#else if (resnumb[i] =="assi" && atnamd[i] =="33" && atname[i] == "HG21") wank[i]="HG2#"	#VAL
#else if (resnumb[i] =="assi" && atnamd[i] =="33" && atname[i] == "HG11") wank[i]="HG1#"	#
#else if (resnumb[i] =="assi" && atnamd[i] =="36" && atname[i] == "HG21") wank[i]="HG2#"	#
#else if (resnumb[i] =="assi" && atnamd[i] =="36" && atname[i] == "HG11") wank[i]="HG1#"	#
#else if (resnumb[i] =="assi" && atnamd[i] =="75" && atname[i] == "HG21") wank[i]="HG2#"	#
#else if (resnumb[i] =="assi" && atnamd[i] =="75" && atname[i] == "HG11") wank[i]="HG1#"	#
#else if (resnumb[i] =="assi" && atnamd[i] =="80" && atname[i] == "HG21") wank[i]="HG2#"	#
#else if (resnumb[i] =="assi" && atnamd[i] =="80" && atname[i] == "HG11") wank[i]="HG1#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="33" && atname[i] == "HG21") wank[i]="HG#"	#VAL
else if (resnumb[i] =="assi" && atnamd[i] =="33" && atname[i] == "HG11") wank[i]="HG#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="36" && atname[i] == "HG21") wank[i]="HG#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="36" && atname[i] == "HG11") wank[i]="HG#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="75" && atname[i] == "HG21") wank[i]="HG#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="75" && atname[i] == "HG11") wank[i]="HG#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="80" && atname[i] == "HG21") wank[i]="HG#"	#
else if (resnumb[i] =="assi" && atnamd[i] =="80" && atname[i] == "HG11") wank[i]="HG#"	#




else wank[i] = atname[i]
}







{if (atnamb[i] =="resid" && atnamc[i] =="71" && atnamd[i] == "HG21") shit[i]="HG2#"		#thr
else if (atnamb[i] =="resid" && atnamc[i] =="41" && atnamd[i] == "HB1") shit[i]="HB#"		#ala
else if (atnamb[i] =="resid" && atnamc[i] =="48" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="52" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="66" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="72" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="76" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="78" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="79" && atnamd[i] == "HB1") shit[i]="HB#"
else if (atnamb[i] =="resid" && atnamc[i] =="85" && atnamd[i] == "HB1") shit[i]="HB#"



#else if (atnamb[i] =="resid" && atnamc[i] =="29" && atnamd[i] == "HD11") shit[i]="HD1#"		#Leu
#else if (atnamb[i] =="resid" && atnamc[i] =="29" && atnamd[i] == "HD21") shit[i]="HD2#"		#Leu
#else if (atnamb[i] =="resid" && atnamc[i] =="37" && atnamd[i] == "HD11") shit[i]="HD1#"		#Leu
#else if (atnamb[i] =="resid" && atnamc[i] =="37" && atnamd[i] == "HD21") shit[i]="HD2#"		#Leu
else if (atnamb[i] =="resid" && atnamc[i] =="29" && atnamd[i] == "HD11") shit[i]="HD#"		#Leu
else if (atnamb[i] =="resid" && atnamc[i] =="29" && atnamd[i] == "HD21") shit[i]="HD#"		#Leu
else if (atnamb[i] =="resid" && atnamc[i] =="37" && atnamd[i] == "HD11") shit[i]="HD#"		#Leu
else if (atnamb[i] =="resid" && atnamc[i] =="37" && atnamd[i] == "HD21") shit[i]="HD#"		#Leu



else if (atnamb[i] =="resid" && atnamc[i] =="44" && atnamd[i] == "HD11") shit[i]="HD1#"		#ILE
else if (atnamb[i] =="resid" && atnamc[i] =="44" && atnamd[i] == "HG21") shit[i]="HG2#"		#ILE

#else if (atnamb[i] =="resid" && atnamc[i] =="33" && atnamd[i] == "HG21") shit[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="33" && atnamd[i] == "HG11") shit[i]="HG1#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="36" && atnamd[i] == "HG21") shit[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="36" && atnamd[i] == "HG11") shit[i]="HG1#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="75" && atnamd[i] == "HG21") shit[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="75" && atnamd[i] == "HG11") shit[i]="HG1#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="80" && atnamd[i] == "HG21") shit[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamc[i] =="80" && atnamd[i] == "HG11") shit[i]="HG1#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="33" && atnamd[i] == "HG21") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="33" && atnamd[i] == "HG11") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="36" && atnamd[i] == "HG21") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="36" && atnamd[i] == "HG11") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="75" && atnamd[i] == "HG21") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="75" && atnamd[i] == "HG11") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="80" && atnamd[i] == "HG21") shit[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamc[i] =="80" && atnamd[i] == "HG11") shit[i]="HG#"		#VAL


else shit[i] = atnamd[i]
}

#a final loop for ambiguous double assignment
{if (atnamb[i] =="resid" && atnamf[i] =="71" && atnamg[i] == "HG21") slag[i]="HG2#"		#thr
else if (atnamb[i] =="resid" && atnamf[i] =="41" && atnamg[i] == "HB1") slag[i]="HB#"		#ala
else if (atnamb[i] =="resid" && atnamf[i] =="48" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="52" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="66" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="72" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="76" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="78" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="79" && atnamg[i] == "HB1") slag[i]="HB#"
else if (atnamb[i] =="resid" && atnamf[i] =="85" && atnamg[i] == "HB1") slag[i]="HB#"



#else if (atnamb[i] =="resid" && atnamf[i] =="29" && atnamg[i] == "HD11") slag[i]="HD1#"		#Leu
#else if (atnamb[i] =="resid" && atnamf[i] =="29" && atnamg[i] == "HD21") slag[i]="HD2#"		#Leu
#else if (atnamb[i] =="resid" && atnamf[i] =="37" && atnamg[i] == "HD11") slag[i]="HD1#"		#Leu
#else if (atnamb[i] =="resid" && atnamf[i] =="37" && atnamg[i] == "HD21") slag[i]="HD2#"		#Leu
else if (atnamb[i] =="resid" && atnamf[i] =="29" && atnamg[i] == "HD11") slag[i]="HD#"		#Leu
else if (atnamb[i] =="resid" && atnamf[i] =="29" && atnamg[i] == "HD21") slag[i]="HD#"		#Leu
else if (atnamb[i] =="resid" && atnamf[i] =="37" && atnamg[i] == "HD11") slag[i]="HD#"		#Leu
else if (atnamb[i] =="resid" && atnamf[i] =="37" && atnamg[i] == "HD21") slag[i]="HD#"		#Leu



else if (atnamb[i] =="resid" && atnamf[i] =="44" && atnamg[i] == "HD11") slag[i]="HD1#"		#ILE
else if (atnamb[i] =="resid" && atnamf[i] =="44" && atnamg[i] == "HG21") slag[i]="HG2#"		#ILE

#else if (atnamb[i] =="resid" && atnamf[i] =="33" && atnamg[i] == "HG21") slag[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="33" && atnamg[i] == "HG11") slag[i]="HG1#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="36" && atnamg[i] == "HG21") slag[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="36" && atnamg[i] == "HG11") slag[i]="HG1#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="75" && atnamg[i] == "HG21") slag[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="75" && atnamg[i] == "HG11") slag[i]="HG1#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="80" && atnamg[i] == "HG21") slag[i]="HG2#"		#VAL
#else if (atnamb[i] =="resid" && atnamf[i] =="80" && atnamg[i] == "HG11") slag[i]="HG1#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="33" && atnamg[i] == "HG21") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="33" && atnamg[i] == "HG11") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="36" && atnamg[i] == "HG21") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="36" && atnamg[i] == "HG11") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="75" && atnamg[i] == "HG21") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="75" && atnamg[i] == "HG11") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="80" && atnamg[i] == "HG21") slag[i]="HG#"		#VAL
else if (atnamb[i] =="resid" && atnamf[i] =="80" && atnamg[i] == "HG11") slag[i]="HG#"		#VAL


else slag[i] = atnamg[i]
}





}


for (i = 1; i <= nra; i++){

if (atnamb[i] =="resid" && atname[i] ~ "fuck"){
i--
#print resnumb[i], atnamb[i],atnamc[i], atnamd[i],atname[i], atnamf[i],atnamg[i], atnamh[i],atnami[i],atnamj[i],atnamk[i]
print resnumb[i], atnamb[i],atnamc[i],atnamd[i],"and name "wank[i] " )"
i++
#print resnumb[i], atnamb[i],atnamc[i], atnamd[i],atname[i], atnamf[i],atnamg[i], atnamh[i],atnami[i],atnamj[i],atnamk[i] 
print "    "resnumb[i], atnamb[i],atnamc[i],"and name "shit[i] " )"
i++
#print "    "resnumb[i], atnamb[i],atnamc[i],"and name "atnamd[i] " )"
#print resnumb[i], atnamb[i],atnamc[i], atnamd[i],atname[i], atnamf[i],atnamg[i], atnamh[i],atnami[i],atnamj[i],atnamk[i]
print  "  6 0.1 0.1  peak "atnamg[i], "weight 1.1 volume ", atnami[i], atnamj[i], atnamk[i], atnaml[i], atnamm[i]
i--
#print "or " resnumb[i-1], atnamb[i-1],atnamc[i-1],atnamd[i-1],"and name "wank[i-1] " )"
print "or " atnamb[i-1],atnamc[i-1],atnamd[i-1],"and name "wank[i-1] " )"
print  resnumb[i], atnamb[i], atnamf[i], "and name " slag[i],")"


}
}

for (i = 1; i <= nra; i++)

{

if (atnamb[i] =="resid" && atname[i] !~ "fuck"){
#print "     "resnumb[i], atnamb[i],atnamc[i],"and name "shit[i] " )"
#print resnumb[i], atnamb[i],atnamc[i], atnamd[i],atname[i], atnamf[i],atnamg[i], atnamh[i],atnami[i],atnamj[i],atnamk[i]
i--
print resnumb[i], atnamb[i], atnamc[i], atnamd[i],"and name " wank[i], ")"
i++
#print resnumb[i], atnamb[i],atnamc[i], atnamd[i],atname[i], atnamf[i],atnamg[i], atnamh[i],atnami[i],atnamj[i],atnamk[i] 
print "    "resnumb[i], atnamb[i],atnamc[i],"and name "shit[i] " )"
i++
#print "    "resnumb[i], atnamb[i],atnamc[i],"and name "atnamd[i] " )"
#print resnumb[i], atnamb[i],atnamc[i], atnamd[i],atname[i], atnamf[i],atnamg[i], atnamh[i],atnami[i],atnamj[i],atnamk[i]
print  "  6 0.1 0.1  peak "atnamg[i], "weight 1.1 volume ", atnami[i], atnamj[i], atnamk[i], atnaml[i], atnamm[i]
#i--

#print "or " resnumb[i-1], atnamb[i-1],atnamc[i-1],atnamd[i-1],"and name "atname[i-1] " )"
#print  resnumb[i], atnamb[i], atnamf[i], "and name " atnamg[i],")"




}
}








}

' $1  
#nawk '{print NR,  $0}'

